{
  "openapi": "3.0.0",
  "info": {
    "title": "AI 毛躁髮質分析",
    "description": "# 概述\n僅用 3 張照片進行 180° 全視角髮絲毛躁度分析\n\n我們的 AI 毛躁髮質分析只需上傳 3 張照片——頭髮的正面、左側與右側視角——即可在數秒內提供精準的髮絲毛躁度分析。\n\n這高效的流程在數秒內提供準確結果，讓企業能依據髮絲毛躁度提供客製化的頭髮解決方案與抗毛躁產品，無需耗時的面對面諮詢、複雜的頭髮測驗，或專用硬體安裝。\n![](https://bcw-media.s3.ap-northeast-1.amazonaws.com/hair_frizzy_S_02_enu_b80c238858.jpg)\n\n## 整合指南\n\n1. **上傳自拍**\n  您可以透過兩種方式之一提供來源圖片：\n\n  - **使用現有的公開圖片網址**\n    無需上傳，您可以在啟動 AI 任務時直接提供可公開存取的圖片網址。\n\n  - **透過 File API 上傳**\n    使用端點：\n    ```\n    POST /s2s/v2.0/file\n    ```\n    這會回傳用於後續任務執行的 `file_id`。\n\n    - ***重要***：僅呼叫 File API 並不會上傳您的檔案。您必須**手動上傳**檔案到**File API 回應中提供的網址**。該網址就是您的上傳目的地，請確保檔案成功傳輸到該處後再繼續。\n\n    在呼叫 AI API 之前，請確保您的檔案已成功上傳。使用 File API 取得上傳網址，然後將檔案上傳到該位置。上傳完成後，您會在回應中取得 ***file_id***，這個 ID 就是您用於存取該檔案相關 AI 功能的依據。\n\n      > **警告：** 請注意，若您未將檔案上傳到 File API 回應中提供的網址，使用 AI API 時會得到 500 Server Error / unknown_internal_error 或 404 Not Found 錯誤。\n\n2.  **執行 AI 任務以取得任務 ID**\n    使用 /s2s/v2.0/task/hair-frizziness-detection 執行 AI 任務。對於目標使用者圖片，提供 ``src_file_url`` 或 ``src_file_id``。並提供要套用的 ``template_id`` 以取得 ``task_id``。\n\n3.  **輪詢以查詢任務狀態直到成功或失敗**\n    使用 ``task_id``，透過輪詢 GET /s2s/v2.0/task/hair-frizziness-detection 監控任務狀態，以取得目前的引擎狀態。在引擎完成任務之前，狀態會維持為 running，此階段不會消耗點數。\n    您也可以實作 webhook，在 AI 任務成功或失敗時接收通知。細節請參考 **[Webhook](../../../../develop/webhook)** 章節。\n\n    > **警告：** 必須在任務的保留期間內輪詢以查詢任務狀態。若在保留期間內沒有輪詢請求，任務將會逾時，即使任務已成功處理。您的點數仍會被消耗。\n\n    > **警告：** 若您查詢已逾時任務的狀態，會收到 InvalidTaskId 錯誤。因此，執行 AI 任務後，您必須在保留期間內輪詢以查詢狀態，直到狀態變為 success 或 error。\n\n4.  **成功後取得 AI 任務的結果**\n    引擎處理您的輸入檔案並生成結果影像後，任務狀態會變為 success。您會取得處理後圖片的網址。\n\n## 輸入與輸出\n* 輸入格式\n![](https://bcw-media.s3.ap-northeast-1.amazonaws.com/hair_frizzy_step_01_ac5c651ea4.png)\n上傳 3 張照片——頭髮的正面、左側與右側視角。\n您可以使用 JS Camera Kit 實作 JavaScript 攝影模組，拍攝 3 張合格的照片。\n\n\n* 輸出格式\nAI 毛躁髮質分析評估髮質類型，並辨識 4 種不同的髮絲毛躁程度——從平滑頭髮到極度毛躁的頭髮，提供關於髮絲毛躁狀況的精準洞察。\n\n| **對應（0–3）** | **術語**            | **說明**                                           |\n| ----------------- | ------------------- | --------------------------------------------------------- |\n| 0             | 不毛躁      | 頭髮看起來平滑，幾乎或完全沒有可見的毛躁。     |\n| 1            | 輕微毛躁 | 可見輕微毛躁；表面質地有輕微的不規則。 |\n| 2             | 毛躁         | 頭髮各處有明顯毛躁；質地明顯紊亂。   |\n| 3             | 極度毛躁  | 強烈且廣泛的毛躁；頭髮質地高度不規則。  |\n\n![](https://bcw-media.s3.ap-northeast-1.amazonaws.com/hair_frizzy_S_01_enu_fcd10905ff.jpg)\n\n* 輸出範例\n```json\n{\n  \"mapping\": 1, // number；結果對應的鍵，選項：[0, 1, 2, 3]\n  \"term\": \"Slightly Frizzy\" // string；與 \"mapping\" 一一對應，選項：[\"Not Frizzy\", \"Slightly Frizzy\", \"Frizzy\", \"Extreme Frizzy\"]\n}\n```\n\n## 檔案規格與錯誤\n* 支援的格式與尺寸\n\n|類型|支援的尺寸|支援的檔案大小|支援的格式|\n|  ----  | ----  | ----  | ----  |\n|AI 毛躁髮質分析|圖片寬與高至少 320 像素，任一維度不超過 4096 像素。若您的圖片其中一邊超過 1080 像素，會自動調整尺寸以符合該限制進行分析。|< 10MB|jpg/png|\n\n* 錯誤代碼\n\n|錯誤代碼|說明|\n|  ----  | ----  |\n|error_mismatch_image_size|請確保您所有的臉部照片（正面、左側、右側）尺寸相同|\n|error_below_min_image_size|若您的圖片寬或高小於 320 像素，尺寸過小無法使用|\n|error_face_position_invalid|您的臉部必須在圖片中完全可見，不可有任何部分被裁切|\n|error_face_position_too_small|您照片中的臉部太小，無法妥善分析|\n|error_face_position_out_of_boundary|您的臉部過大，或部分超出照片邊緣|\n|error_insufficient_lighting|光線過暗，導致難以分析|\n|error_face_angle_invalid|您的臉部角度不太正確。正面拍攝時，請讓頭部偏離直線不超過 10 度。側面拍攝時，角度應超過 15 度|\n\n* 環境與相依性\n\n| 範例程式語言 / 工具 | 建議的執行環境版本 |\n|---|---|\n| cURL | - bash >= 3.2</br>   - curl >= 7.58（現代 TLS/HTTP 支援）</br>   - jq >= 1.6（穩健的 JSON 解析） |\n| Node.js（JavaScript） | Node >= 18（支援全域 fetch） |\n| JavaScript | - Chrome / Edge >= 80</br>   - Firefox >= 74</br>   - Safari >= 13.1 |\n| PHP | PHP >= 7.4（現代 TLS/相容性），ext-curl（建議）或 allow_url_fopen=On + ext-openssl、ext-json |\n| Python | Python >= 3.10（支援 f-strings），requests >= 2.20.0 |\n| Java | Java 11+（支援 HttpClient），Jackson Databind >= 2.12.0 |\n\n---\n\n## JS Camera Kit\n{% partial file=\"/_partials/js-camera-kit.md\" /%}\n\n---\n\n## 點數消耗\n\n| AI 功能 | 消耗的點數 |\n|---|---|\n| AI 毛躁髮質分析 V1.0 | 2 |\n\n---\n",
    "version": "",
    "termsOfService": "https://www.makeupar.com/perfectbeauty/youcam/terms-of-service-api",
    "contact": {
      "email": "YouCamOnlineEditor_API@perfectcorp.com"
    },
    "license": {
      "name": "Privacy policy",
      "url": "https://www.makeupar.com/perfectbeauty/youcam/privacy-policy-api"
    }
  },
  "servers": [
    {
      "url": "https://yce-api-01.makeupar.com"
    }
  ],
  "tags": [
    {
      "name": "V1.0",
      "description": "AI 毛躁髮質分析 API 可讓您使用三角度輸入（正面、右側、左側），偵測圖片中頭髮的毛躁程度。"
    }
  ],
  "paths": {
    "/s2s/v2.0/task/hair-frizziness-detection": {
      "post": {
        "summary": "執行髮絲毛躁度偵測任務。",
        "description": "查詢任務狀態請參考輪詢指南。",
        "tags": [
          "V1.0"
        ],
        "security": [
          {
            "BearerAuthenticationV2": []
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BasicFaceAttrReqFaceThreeAngle"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "任務執行成功",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BasicRunTaskResponseV2"
                }
              }
            }
          },
          "400": {
            "description": "任務執行失敗",
            "content": {
              "application/json": {
                "schema": {
                  "allOf": [
                    {
                      "$ref": "#/components/responses/RunError"
                    }
                  ]
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/InvalidApiKey"
          },
          "429": {
            "description": "在指定時間內請求過多",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object"
                }
              }
            }
          }
        }
      }
    },
    "/s2s/v2.0/task/hair-frizziness-detection/{task_id}": {
      "get": {
        "summary": "查詢髮絲毛躁度偵測任務的狀態。",
        "tags": [
          "V1.0"
        ],
        "security": [
          {
            "BearerAuthenticationV2": []
          }
        ],
        "parameters": [
          {
            "name": "task_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "example": "grH0CvsgXuAIHLUzD0V1Ol34hoet3R1tvdbtiVHrDb6_UqCLKIejAIajwxrhOAfe"
            },
            "description": "要查詢的任務 ID"
          }
        ],
        "responses": {
          "200": {
            "description": "成功查詢任務狀態",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/TaskStatusResponseHairFrizz"
                }
              }
            }
          },
          "400": {
            "$ref": "#/components/responses/InvalidTaskId"
          },
          "401": {
            "$ref": "#/components/responses/InvalidApiKey"
          },
          "500": {
            "$ref": "#/components/responses/TaskTimeout"
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "FileV1.1": {
        "title": "File V1.1",
        "description": "這個物件代表一個檔案。",
        "type": "object",
        "required": [
          "files"
        ],
        "properties": {
          "files": {
            "type": "array",
            "items": {
              "type": "object",
              "required": [
                "content_type",
                "file_name",
                "file_size"
              ],
              "properties": {
                "content_type": {
                  "type": "string",
                  "example": "image/jpg",
                  "description": "這個檔案的內容 MIME 類型。目前可用的值列於 enum 中。"
                },
                "file_name": {
                  "type": "string",
                  "example": "my-selfie.jpg",
                  "description": "這個檔案的名稱"
                },
                "file_size": {
                  "type": "integer",
                  "example": 50000,
                  "description": "這個檔案的內容長度，以位元組計。不應超過 10MB。"
                }
              }
            }
          }
        }
      },
      "BasicFileResponse": {
        "type": "object",
        "properties": {
          "files": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "content_type": {
                  "type": "string",
                  "example": "image/jpg",
                  "description": "這個檔案的內容 MIME 類型。"
                },
                "file_name": {
                  "type": "string",
                  "example": "my-selfie.jpg",
                  "description": "這個檔案的名稱"
                },
                "file_id": {
                  "type": "string",
                  "example": "U8aqJbsXGT537jtGnEDFHqxdDXqh8+oTF/cSkLimzuvVwMP+Jb1XbjPsf7ZgUgLY",
                  "description": "這個檔案的 ID。其他執行任務的 API 會需要這個 `file_id`。"
                },
                "requests": {
                  "type": "array",
                  "description": "使用下方的 `url`、`headers`、`method` 上傳檔案。完成後，使用 `file_id` 繼續呼叫執行任務的 API。",
                  "items": {
                    "type": "object",
                    "properties": {
                      "headers": {
                        "type": "object",
                        "example": {
                          "Content-Type": "image/jpg",
                          "Content-Length": 50000
                        },
                        "description": "上傳檔案時要納入的標頭"
                      },
                      "url": {
                        "type": "string",
                        "example": "https://example.com/presigned-upload-url",
                        "description": "上傳這個檔案的網址"
                      },
                      "method": {
                        "type": "string",
                        "example": "PUT",
                        "description": "上傳這個檔案所用的 HTTP 方法"
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      "FileResponseV2": {
        "type": "object",
        "properties": {
          "status": {
            "type": "integer",
            "example": 200,
            "description": "回應狀態"
          },
          "data": {
            "$ref": "#/components/schemas/BasicFileResponse"
          }
        }
      },
      "BasicFaceAttrReqFaceThreeAngleWithSrcFileUrls": {
        "title": "以 3 個角度的來源檔案網址執行任務",
        "type": "object",
        "required": [
          "src_file_urls"
        ],
        "properties": {
          "src_file_urls": {
            "type": "array",
            "minItems": 3,
            "maxItems": 3,
            "description": "來自上傳檔案 API 的檔案網址。來源照片序列的檔案 ID 依序為 'frontFace'、'rightFace' 與 'leftFace'。應提供 'src_file_urls' 或 'src_file_ids' 其中之一。",
            "example": [
              "https://example.com/selfie.jpg",
              "https://example.com/selfie.jpg",
              "https://example.com/selfie.jpg"
            ],
            "items": {
              "type": "string"
            }
          }
        }
      },
      "BasicFaceAttrReqFaceThreeAngleWithSrcFileIds": {
        "title": "以 3 個角度的來源檔案 ID 執行任務",
        "type": "object",
        "required": [
          "src_file_ids"
        ],
        "properties": {
          "src_file_ids": {
            "type": "array",
            "minItems": 3,
            "maxItems": 3,
            "description": "來自上傳檔案 API 的檔案 ID。來源照片序列的檔案 ID 依序為 'frontFace'、'rightFace' 與 'leftFace'。應提供 'src_file_urls' 或 'src_file_ids' 其中之一。",
            "example": [
              "pfNK5PuRe0MrwLHcGA3DOmB1ahwfXTbYHjv+KoBIxbE=",
              "pkVzplMv8Y1QPgHbqtKfyJmg+xJDUbTP16YijZ3qARNf",
              "B5LNohvvO+7d/78Ymuhp6vMiSooN/5DX9oVuupzkKctf"
            ],
            "items": {
              "type": "string"
            }
          }
        }
      },
      "BasicFaceAttrReqFaceThreeAngle": {
        "anyOf": [
          {
            "$ref": "#/components/schemas/BasicFaceAttrReqFaceThreeAngleWithSrcFileUrls"
          },
          {
            "$ref": "#/components/schemas/BasicFaceAttrReqFaceThreeAngleWithSrcFileIds"
          }
        ]
      },
      "BasicRunTaskResponseV2": {
        "type": "object",
        "properties": {
          "status": {
            "type": "integer",
            "description": "回應狀態",
            "example": 200
          },
          "data": {
            "type": "object",
            "properties": {
              "task_id": {
                "type": "string",
                "description": "這個任務的 ID。任務結果可以此 ID 查詢，有效期限 24 小時。",
                "example": "grH0CvsgXuAIHLUzD0V1Ol34hoet3R1tvdbtiVHrDb6_UqCLKIejAIajwxrhOAfe"
              }
            }
          }
        }
      },
      "EngineErrorCode": {
        "type": "string",
        "nullable": true,
        "enum": [
          "exceed_max_filesize",
          "invalid_parameter",
          "error_download_image",
          "error_download_mask",
          "error_decode_image",
          "error_decode_mask",
          "error_nsfw_content_detected",
          "error_no_face",
          "error_pose",
          "error_face_parsing",
          "error_inference",
          "exceed_nsfw_retry_limits",
          "error_upload",
          "unknown_internal_error"
        ],
        "description": "錯誤：\n- `exceed_max_filesize` - 輸入檔案大小超過上限\n- `invalid_parameter` - 參數值無效\n- `error_download_image` - 下載來源圖片錯誤\n- `error_download_mask` - 下載遮罩圖片錯誤\n- `error_decode_image` - 解碼來源圖片錯誤\n- `error_decode_mask` - 解碼遮罩圖片錯誤\n- `error_nsfw_content_detected` - 在來源圖片中偵測到 NSFW 內容\n- `error_no_face` - 來源圖片未偵測到臉部\n- `error_pose` - 在來源圖片偵測姿勢失敗\n- `error_face_parsing` - 在來源圖片進行人臉分割失敗\n- `error_inference` - 推論流程錯誤\n- `exceed_nsfw_retry_limits` - 超過重試上限，以避免生成 NSFW 圖片\n- `error_upload` - 上傳結果圖片錯誤\n- `unknown_internal_error` - 其他\n"
      },
      "BasicFaceAttrRespHairFrizziness": {
        "type": "object",
        "properties": {
          "mapping": {
            "type": "number",
            "description": "用於對應結果的索引鍵",
            "enum": [
              0,
              1,
              2,
              3
            ]
          },
          "term": {
            "type": "string",
            "description": "與 \"mapping\" 一比一對應",
            "enum": [
              "Not Frizzy",
              "Slightly Frizzy",
              "Frizzy",
              "Extreme Frizzy"
            ]
          }
        }
      },
      "TaskStatusResponseHairFrizz": {
        "type": "object",
        "properties": {
          "status": {
            "type": "integer",
            "description": "回應狀態",
            "example": 200
          },
          "data": {
            "type": "object",
            "properties": {
              "task_status": {
                "type": "string",
                "enum": [
                  "running",
                  "success",
                  "error"
                ],
                "description": "這個任務的狀態"
              },
              "error": {
                "$ref": "#/components/schemas/EngineErrorCode"
              },
              "error_message": {
                "type": "string",
                "description": "錯誤的詳細說明"
              },
              "results": {
                "allOf": [
                  {
                    "type": "object",
                    "properties": {
                      "hair_frizziness": {
                        "$ref": "#/components/schemas/BasicFaceAttrRespHairFrizziness"
                      }
                    }
                  }
                ]
              }
            }
          }
        }
      }
    },
    "responses": {
      "InvalidParameters": {
        "description": "請求參數無效",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "status": {
                  "type": "integer",
                  "example": 400,
                  "description": "回應狀態"
                },
                "error": {
                  "type": "string",
                  "description": "錯誤訊息",
                  "example": "The operation could not be completed"
                },
                "error_code": {
                  "type": "string",
                  "enum": [
                    "InvalidParameters"
                  ],
                  "description": "錯誤代碼：\n  * InvalidParameters - 請求參數或內容無效\n"
                }
              }
            }
          }
        }
      },
      "InvalidApiKey": {
        "description": "API Key 無效、已停用或已到期",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "status": {
                  "type": "integer",
                  "example": 401,
                  "description": "回應狀態"
                },
                "error_code": {
                  "type": "string",
                  "enum": [
                    "InvalidApiKey",
                    "InactiveApiKey",
                    "ExpiredApiKey"
                  ],
                  "description": "錯誤代碼：\n  * InvalidApiKey - 未提供 API Key，或 API Key 無效\n  * InactiveApiKey - API Key 已停用\n  * ExpiredApiKey - API Key 已到期\n"
                }
              }
            }
          }
        }
      },
      "RunError": {
        "type": "object",
        "properties": {
          "status": {
            "type": "integer",
            "description": "回應狀態",
            "example": 400
          },
          "error": {
            "type": "string",
            "description": "錯誤訊息",
            "example": "The operation could not be completed"
          },
          "error_code": {
            "type": "string",
            "enum": [
              "CreditInsufficiency",
              "InvalidStyleGroup",
              "InvalidStyle",
              "BadRequest",
              "InvalidParameters"
            ],
            "description": "錯誤代碼：\n  * CreditInsufficiency - 點數不足，無法執行\n  * BadRequest - 請求參數不如預期\n  * InvalidStyleGroup - 風格群組 id 無效\n  * InvalidStyle - 風格 id 無效\n  * InvalidParameters - 請求參數無效\n"
          }
        }
      },
      "InvalidTaskId": {
        "description": "任務 id 無效",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "status": {
                  "type": "integer",
                  "description": "回應狀態",
                  "example": 400
                },
                "error_code": {
                  "type": "string",
                  "enum": [
                    "InvalidTaskId"
                  ],
                  "description": "錯誤代碼：\n  * InvalidTaskId - 任務 id 無效\n"
                }
              }
            }
          }
        }
      },
      "TooManyRequests": {
        "description": "在指定時間內請求過多"
      },
      "TaskTimeout": {
        "description": "任務在預期時間內沒有回應",
        "content": {
          "application/json": {
            "schema": {
              "type": "object",
              "properties": {
                "status": {
                  "type": "integer",
                  "description": "回應狀態",
                  "example": 500
                },
                "error_code": {
                  "type": "string",
                  "enum": [
                    "TaskTimeout"
                  ],
                  "description": "錯誤代碼：\n  * TaskTimeout - 任務在預期時間內沒有回應\n"
                }
              }
            }
          }
        }
      }
    },
    "securitySchemes": {
      "BearerAuthenticationV2": {
        "type": "http",
        "scheme": "bearer",
        "description": "使用標準的 'Bearer authentication'。請在標頭中放入您的 'API Key'：`Authorization:Bearer YOUR_API_KEY`。請注意 'Bearer' 與 'YOUR_API_KEY' 之間有一個空格。"
      }
    }
  }
}